'''
    Solution to CS 224 Closed Lab 01.  See pdf for details.

    Author: David Mathias
    Date: February 7, 2020
'''

import csv
from random import shuffle
    

def main():
    f_name = 'data.csv'
    
    # read the csv file contents into a list
    f_in = open(f_name, 'r')
    in_lines = csv.reader(f_in.readlines())
    f_in.close()

    # elements read are strings -- convert to numeric types and store in new list
    # data_lines is the list you will work with
    data_lines = []
    for line in in_lines:
        data_lines.append([float(x) if '.' in x else int(x) for x in line])

        
    # part 1 - sort by player type
    sorted_by_type = sorted(data_lines, key=lambda e: e[-1])
    print()
    print('Part 1: Sort by player type:')
    for i in sorted_by_type:
        print(i[-6:])
    print('\n')
    
    # part 1 - sort by avg score
    sorted_by_score = sorted(data_lines, key=lambda e: e[-6])
    print('Part 1: Sort by avg score:')
    for i in sorted_by_score:
        print(i[-6:])
    print('\n\n')
    
    
    # part 2 - count of each player type and report count of 0
    counts = [0] * 50
    print('Part 2: Print counts by player type and indices with count of 0:')
    for e in data_lines:
        counts[e[-1]] += 1
    print('Counts: {}'.format(counts))
    
    if not all(counts):
        print('Index with count of 0: {}\n'.format(counts.index(0)))
        
    print('\n\n')
    
    
    # part 3 - sort by player type and by score within player type
    temp_list = []
    data_lines.sort(key=lambda e: e[-1])
    i = 0
    for j in counts:
        j = j + i
        temp_list.extend(sorted(data_lines[i:j], key=lambda e: e[-6]))
        i = j
    data_lines = temp_list

    print('Part 3: Sort by player type and score within player type:')
    for k in data_lines:
        print(k[-6:])
    print('\n\n')
    
    
    # part 3 - alternate method
    shuffle(data_lines)
    data_lines.sort(key=lambda e: e[-6])
    data_lines.sort(key=lambda e: e[-1])
    
    print('Part 3: Sort by player type and score within player type (the Pythonic way):')
    for k in data_lines:
        print(k[-6:])
    print('\n')

        
if __name__ == "__main__":
    main()
